%% -*- coding: utf-8 -*-
%% @private
%% Automatically generated, do not edit
%% Generated by gpb_compile version 4.7.3
-module(grpcbox_task_pb).

-export([encode_msg/2, encode_msg/3]).
-export([decode_msg/2, decode_msg/3]).
-export([merge_msgs/3, merge_msgs/4]).
-export([verify_msg/2, verify_msg/3]).
-export([get_msg_defs/0]).
-export([get_msg_names/0]).
-export([get_group_names/0]).
-export([get_msg_or_group_names/0]).
-export([get_enum_names/0]).
-export([find_msg_def/1, fetch_msg_def/1]).
-export([find_enum_def/1, fetch_enum_def/1]).
-export([enum_symbol_by_value/2, enum_value_by_symbol/2]).
-export(['enum_symbol_by_value_task.Status'/1, 'enum_value_by_symbol_task.Status'/1]).
-export([get_service_names/0]).
-export([get_service_def/1]).
-export([get_rpc_names/1]).
-export([find_rpc_def/2, fetch_rpc_def/2]).
-export([fqbin_to_service_name/1]).
-export([service_name_to_fqbin/1]).
-export([fqbins_to_service_and_rpc_name/2]).
-export([service_and_rpc_name_to_fqbins/2]).
-export([fqbin_to_msg_name/1]).
-export([msg_name_to_fqbin/1]).
-export([fqbin_to_enum_name/1]).
-export([enum_name_to_fqbin/1]).
-export([get_package_name/0]).
-export([uses_packages/0]).
-export([source_basename/0]).
-export([get_all_source_basenames/0]).
-export([get_all_proto_names/0]).
-export([get_msg_containment/1]).
-export([get_pkg_containment/1]).
-export([get_service_containment/1]).
-export([get_rpc_containment/1]).
-export([get_enum_containment/1]).
-export([get_proto_by_msg_name_as_fqbin/1]).
-export([get_proto_by_service_name_as_fqbin/1]).
-export([get_proto_by_enum_name_as_fqbin/1]).
-export([get_protos_by_pkg_name_as_fqbin/1]).
-export([descriptor/0, descriptor/1]).
-export([gpb_version_as_string/0, gpb_version_as_list/0]).


%% enumerated types
-type 'task.Status'() :: 'UNDEFINED' | 'NEW' | 'RUNNING' | 'CANCELED' | 'DONE' | 'ERROR'.
-export_type(['task.Status'/0]).

%% message types
-type get_task_request() ::
      #{task_id                 => iodata()         % = 1
       }.

-type cancel_task_request() ::
      #{task_id                 => iodata()         % = 1
       }.

-type task() ::
      #{id                      => iodata(),        % = 1
        created_at              => timestamp(),     % = 2
        updated_at              => timestamp(),     % = 3
        status                  => 'UNDEFINED' | 'NEW' | 'RUNNING' | 'CANCELED' | 'DONE' | 'ERROR' | integer(), % = 4, enum task.Status
        result                  => {error, iodata()} | {response_file_id, iodata()} % oneof
       }.

-type timestamp() ::
      #{seconds                 => integer(),       % = 1, 32 bits
        nanos                   => integer()        % = 2, 32 bits
       }.

-export_type(['get_task_request'/0, 'cancel_task_request'/0, 'task'/0, 'timestamp'/0]).

-spec encode_msg(get_task_request() | cancel_task_request() | task() | timestamp(), atom()) -> binary().
encode_msg(Msg, MsgName) when is_atom(MsgName) ->
    encode_msg(Msg, MsgName, []).

-spec encode_msg(get_task_request() | cancel_task_request() | task() | timestamp(), atom(), list()) -> binary().
encode_msg(Msg, MsgName, Opts) ->
    case proplists:get_bool(verify, Opts) of
        true -> verify_msg(Msg, MsgName, Opts);
        false -> ok
    end,
    TrUserData = proplists:get_value(user_data, Opts),
    case MsgName of
        get_task_request ->
            encode_msg_get_task_request(id(Msg, TrUserData),
                                        TrUserData);
        cancel_task_request ->
            encode_msg_cancel_task_request(id(Msg, TrUserData),
                                           TrUserData);
        task ->
            encode_msg_task(id(Msg, TrUserData), TrUserData);
        timestamp ->
            encode_msg_timestamp(id(Msg, TrUserData), TrUserData)
    end.


encode_msg_get_task_request(Msg, TrUserData) ->
    encode_msg_get_task_request(Msg, <<>>, TrUserData).


encode_msg_get_task_request(#{} = M, Bin, TrUserData) ->
    case M of
        #{task_id := F1} ->
            begin
                TrF1 = id(F1, TrUserData),
                case is_empty_string(TrF1) of
                    true -> Bin;
                    false ->
                        e_type_string(TrF1, <<Bin/binary, 10>>, TrUserData)
                end
            end;
        _ -> Bin
    end.

encode_msg_cancel_task_request(Msg, TrUserData) ->
    encode_msg_cancel_task_request(Msg, <<>>, TrUserData).


encode_msg_cancel_task_request(#{} = M, Bin,
                               TrUserData) ->
    case M of
        #{task_id := F1} ->
            begin
                TrF1 = id(F1, TrUserData),
                case is_empty_string(TrF1) of
                    true -> Bin;
                    false ->
                        e_type_string(TrF1, <<Bin/binary, 10>>, TrUserData)
                end
            end;
        _ -> Bin
    end.

encode_msg_task(Msg, TrUserData) ->
    encode_msg_task(Msg, <<>>, TrUserData).


encode_msg_task(#{} = M, Bin, TrUserData) ->
    B1 = case M of
             #{id := F1} ->
                 begin
                     TrF1 = id(F1, TrUserData),
                     case is_empty_string(TrF1) of
                         true -> Bin;
                         false ->
                             e_type_string(TrF1, <<Bin/binary, 10>>, TrUserData)
                     end
                 end;
             _ -> Bin
         end,
    B2 = case M of
             #{created_at := F2} ->
                 begin
                     TrF2 = id(F2, TrUserData),
                     if TrF2 =:= undefined -> B1;
                        true ->
                            e_mfield_task_created_at(TrF2,
                                                     <<B1/binary, 18>>,
                                                     TrUserData)
                     end
                 end;
             _ -> B1
         end,
    B3 = case M of
             #{updated_at := F3} ->
                 begin
                     TrF3 = id(F3, TrUserData),
                     if TrF3 =:= undefined -> B2;
                        true ->
                            e_mfield_task_updated_at(TrF3,
                                                     <<B2/binary, 26>>,
                                                     TrUserData)
                     end
                 end;
             _ -> B2
         end,
    B4 = case M of
             #{status := F4} ->
                 begin
                     TrF4 = id(F4, TrUserData),
                     if TrF4 =:= 'UNDEFINED'; TrF4 =:= 0 -> B3;
                        true ->
                            'e_enum_task.Status'(TrF4,
                                                 <<B3/binary, 32>>,
                                                 TrUserData)
                     end
                 end;
             _ -> B3
         end,
    case M of
        #{result := F5} ->
            case id(F5, TrUserData) of
                {error, TF5} ->
                    begin
                        TrTF5 = id(TF5, TrUserData),
                        e_type_string(TrTF5, <<B4/binary, 42>>, TrUserData)
                    end;
                {response_file_id, TF5} ->
                    begin
                        TrTF5 = id(TF5, TrUserData),
                        e_type_string(TrTF5, <<B4/binary, 50>>, TrUserData)
                    end
            end;
        _ -> B4
    end.

encode_msg_timestamp(Msg, TrUserData) ->
    encode_msg_timestamp(Msg, <<>>, TrUserData).


encode_msg_timestamp(#{} = M, Bin, TrUserData) ->
    B1 = case M of
             #{seconds := F1} ->
                 begin
                     TrF1 = id(F1, TrUserData),
                     if TrF1 =:= 0 -> Bin;
                        true ->
                            e_type_int64(TrF1, <<Bin/binary, 8>>, TrUserData)
                     end
                 end;
             _ -> Bin
         end,
    case M of
        #{nanos := F2} ->
            begin
                TrF2 = id(F2, TrUserData),
                if TrF2 =:= 0 -> B1;
                   true ->
                       e_type_int32(TrF2, <<B1/binary, 16>>, TrUserData)
                end
            end;
        _ -> B1
    end.

e_mfield_task_created_at(Msg, Bin, TrUserData) ->
    SubBin = encode_msg_timestamp(Msg, <<>>, TrUserData),
    Bin2 = e_varint(byte_size(SubBin), Bin),
    <<Bin2/binary, SubBin/binary>>.

e_mfield_task_updated_at(Msg, Bin, TrUserData) ->
    SubBin = encode_msg_timestamp(Msg, <<>>, TrUserData),
    Bin2 = e_varint(byte_size(SubBin), Bin),
    <<Bin2/binary, SubBin/binary>>.

'e_enum_task.Status'('UNDEFINED', Bin, _TrUserData) ->
    <<Bin/binary, 0>>;
'e_enum_task.Status'('NEW', Bin, _TrUserData) ->
    <<Bin/binary, 1>>;
'e_enum_task.Status'('RUNNING', Bin, _TrUserData) ->
    <<Bin/binary, 2>>;
'e_enum_task.Status'('CANCELED', Bin, _TrUserData) ->
    <<Bin/binary, 3>>;
'e_enum_task.Status'('DONE', Bin, _TrUserData) ->
    <<Bin/binary, 4>>;
'e_enum_task.Status'('ERROR', Bin, _TrUserData) ->
    <<Bin/binary, 5>>;
'e_enum_task.Status'(V, Bin, _TrUserData) ->
    e_varint(V, Bin).

-compile({nowarn_unused_function,e_type_sint/3}).
e_type_sint(Value, Bin, _TrUserData) when Value >= 0 ->
    e_varint(Value * 2, Bin);
e_type_sint(Value, Bin, _TrUserData) ->
    e_varint(Value * -2 - 1, Bin).

-compile({nowarn_unused_function,e_type_int32/3}).
e_type_int32(Value, Bin, _TrUserData)
    when 0 =< Value, Value =< 127 ->
    <<Bin/binary, Value>>;
e_type_int32(Value, Bin, _TrUserData) ->
    <<N:64/unsigned-native>> = <<Value:64/signed-native>>,
    e_varint(N, Bin).

-compile({nowarn_unused_function,e_type_int64/3}).
e_type_int64(Value, Bin, _TrUserData)
    when 0 =< Value, Value =< 127 ->
    <<Bin/binary, Value>>;
e_type_int64(Value, Bin, _TrUserData) ->
    <<N:64/unsigned-native>> = <<Value:64/signed-native>>,
    e_varint(N, Bin).

-compile({nowarn_unused_function,e_type_bool/3}).
e_type_bool(true, Bin, _TrUserData) ->
    <<Bin/binary, 1>>;
e_type_bool(false, Bin, _TrUserData) ->
    <<Bin/binary, 0>>;
e_type_bool(1, Bin, _TrUserData) -> <<Bin/binary, 1>>;
e_type_bool(0, Bin, _TrUserData) -> <<Bin/binary, 0>>.

-compile({nowarn_unused_function,e_type_string/3}).
e_type_string(S, Bin, _TrUserData) ->
    Utf8 = unicode:characters_to_binary(S),
    Bin2 = e_varint(byte_size(Utf8), Bin),
    <<Bin2/binary, Utf8/binary>>.

-compile({nowarn_unused_function,e_type_bytes/3}).
e_type_bytes(Bytes, Bin, _TrUserData)
    when is_binary(Bytes) ->
    Bin2 = e_varint(byte_size(Bytes), Bin),
    <<Bin2/binary, Bytes/binary>>;
e_type_bytes(Bytes, Bin, _TrUserData)
    when is_list(Bytes) ->
    BytesBin = iolist_to_binary(Bytes),
    Bin2 = e_varint(byte_size(BytesBin), Bin),
    <<Bin2/binary, BytesBin/binary>>.

-compile({nowarn_unused_function,e_type_fixed32/3}).
e_type_fixed32(Value, Bin, _TrUserData) ->
    <<Bin/binary, Value:32/little>>.

-compile({nowarn_unused_function,e_type_sfixed32/3}).
e_type_sfixed32(Value, Bin, _TrUserData) ->
    <<Bin/binary, Value:32/little-signed>>.

-compile({nowarn_unused_function,e_type_fixed64/3}).
e_type_fixed64(Value, Bin, _TrUserData) ->
    <<Bin/binary, Value:64/little>>.

-compile({nowarn_unused_function,e_type_sfixed64/3}).
e_type_sfixed64(Value, Bin, _TrUserData) ->
    <<Bin/binary, Value:64/little-signed>>.

-compile({nowarn_unused_function,e_type_float/3}).
e_type_float(V, Bin, _) when is_number(V) ->
    <<Bin/binary, V:32/little-float>>;
e_type_float(infinity, Bin, _) ->
    <<Bin/binary, 0:16, 128, 127>>;
e_type_float('-infinity', Bin, _) ->
    <<Bin/binary, 0:16, 128, 255>>;
e_type_float(nan, Bin, _) ->
    <<Bin/binary, 0:16, 192, 127>>.

-compile({nowarn_unused_function,e_type_double/3}).
e_type_double(V, Bin, _) when is_number(V) ->
    <<Bin/binary, V:64/little-float>>;
e_type_double(infinity, Bin, _) ->
    <<Bin/binary, 0:48, 240, 127>>;
e_type_double('-infinity', Bin, _) ->
    <<Bin/binary, 0:48, 240, 255>>;
e_type_double(nan, Bin, _) ->
    <<Bin/binary, 0:48, 248, 127>>.

-compile({nowarn_unused_function,e_varint/3}).
e_varint(N, Bin, _TrUserData) -> e_varint(N, Bin).

-compile({nowarn_unused_function,e_varint/2}).
e_varint(N, Bin) when N =< 127 -> <<Bin/binary, N>>;
e_varint(N, Bin) ->
    Bin2 = <<Bin/binary, (N band 127 bor 128)>>,
    e_varint(N bsr 7, Bin2).

is_empty_string("") -> true;
is_empty_string(<<>>) -> true;
is_empty_string(L) when is_list(L) ->
    not string_has_chars(L);
is_empty_string(B) when is_binary(B) -> false.

string_has_chars([C | _]) when is_integer(C) -> true;
string_has_chars([H | T]) ->
    case string_has_chars(H) of
        true -> true;
        false -> string_has_chars(T)
    end;
string_has_chars(B)
    when is_binary(B), byte_size(B) =/= 0 ->
    true;
string_has_chars(C) when is_integer(C) -> true;
string_has_chars(<<>>) -> false;
string_has_chars([]) -> false.


decode_msg(Bin, MsgName) when is_binary(Bin) ->
    decode_msg(Bin, MsgName, []).

decode_msg(Bin, MsgName, Opts) when is_binary(Bin) ->
    TrUserData = proplists:get_value(user_data, Opts),
    decode_msg_1_catch(Bin, MsgName, TrUserData).

-ifdef('OTP_RELEASE').
decode_msg_1_catch(Bin, MsgName, TrUserData) ->
    try decode_msg_2_doit(MsgName, Bin, TrUserData)
    catch Class:Reason:StackTrace -> error({gpb_error,{decoding_failure, {Bin, MsgName, {Class, Reason, StackTrace}}}})
    end.
-else.
decode_msg_1_catch(Bin, MsgName, TrUserData) ->
    try decode_msg_2_doit(MsgName, Bin, TrUserData)
    catch Class:Reason ->
        StackTrace = erlang:get_stacktrace(),
        error({gpb_error,{decoding_failure, {Bin, MsgName, {Class, Reason, StackTrace}}}})
    end.
-endif.

decode_msg_2_doit(get_task_request, Bin, TrUserData) ->
    id(decode_msg_get_task_request(Bin, TrUserData),
       TrUserData);
decode_msg_2_doit(cancel_task_request, Bin,
                  TrUserData) ->
    id(decode_msg_cancel_task_request(Bin, TrUserData),
       TrUserData);
decode_msg_2_doit(task, Bin, TrUserData) ->
    id(decode_msg_task(Bin, TrUserData), TrUserData);
decode_msg_2_doit(timestamp, Bin, TrUserData) ->
    id(decode_msg_timestamp(Bin, TrUserData), TrUserData).



decode_msg_get_task_request(Bin, TrUserData) ->
    dfp_read_field_def_get_task_request(Bin,
                                        0,
                                        0,
                                        id(<<>>, TrUserData),
                                        TrUserData).

dfp_read_field_def_get_task_request(<<10, Rest/binary>>,
                                    Z1, Z2, F@_1, TrUserData) ->
    d_field_get_task_request_task_id(Rest,
                                     Z1,
                                     Z2,
                                     F@_1,
                                     TrUserData);
dfp_read_field_def_get_task_request(<<>>, 0, 0, F@_1,
                                    _) ->
    #{task_id => F@_1};
dfp_read_field_def_get_task_request(Other, Z1, Z2, F@_1,
                                    TrUserData) ->
    dg_read_field_def_get_task_request(Other,
                                       Z1,
                                       Z2,
                                       F@_1,
                                       TrUserData).

dg_read_field_def_get_task_request(<<1:1, X:7,
                                     Rest/binary>>,
                                   N, Acc, F@_1, TrUserData)
    when N < 32 - 7 ->
    dg_read_field_def_get_task_request(Rest,
                                       N + 7,
                                       X bsl N + Acc,
                                       F@_1,
                                       TrUserData);
dg_read_field_def_get_task_request(<<0:1, X:7,
                                     Rest/binary>>,
                                   N, Acc, F@_1, TrUserData) ->
    Key = X bsl N + Acc,
    case Key of
        10 ->
            d_field_get_task_request_task_id(Rest,
                                             0,
                                             0,
                                             F@_1,
                                             TrUserData);
        _ ->
            case Key band 7 of
                0 ->
                    skip_varint_get_task_request(Rest,
                                                 0,
                                                 0,
                                                 F@_1,
                                                 TrUserData);
                1 ->
                    skip_64_get_task_request(Rest, 0, 0, F@_1, TrUserData);
                2 ->
                    skip_length_delimited_get_task_request(Rest,
                                                           0,
                                                           0,
                                                           F@_1,
                                                           TrUserData);
                3 ->
                    skip_group_get_task_request(Rest,
                                                Key bsr 3,
                                                0,
                                                F@_1,
                                                TrUserData);
                5 ->
                    skip_32_get_task_request(Rest, 0, 0, F@_1, TrUserData)
            end
    end;
dg_read_field_def_get_task_request(<<>>, 0, 0, F@_1,
                                   _) ->
    #{task_id => F@_1}.

d_field_get_task_request_task_id(<<1:1, X:7,
                                   Rest/binary>>,
                                 N, Acc, F@_1, TrUserData)
    when N < 57 ->
    d_field_get_task_request_task_id(Rest,
                                     N + 7,
                                     X bsl N + Acc,
                                     F@_1,
                                     TrUserData);
d_field_get_task_request_task_id(<<0:1, X:7,
                                   Rest/binary>>,
                                 N, Acc, _, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bytes:Len/binary, Rest2/binary>> = Rest,
                             {id(binary:copy(Bytes), TrUserData), Rest2}
                         end,
    dfp_read_field_def_get_task_request(RestF,
                                        0,
                                        0,
                                        NewFValue,
                                        TrUserData).

skip_varint_get_task_request(<<1:1, _:7, Rest/binary>>,
                             Z1, Z2, F@_1, TrUserData) ->
    skip_varint_get_task_request(Rest,
                                 Z1,
                                 Z2,
                                 F@_1,
                                 TrUserData);
skip_varint_get_task_request(<<0:1, _:7, Rest/binary>>,
                             Z1, Z2, F@_1, TrUserData) ->
    dfp_read_field_def_get_task_request(Rest,
                                        Z1,
                                        Z2,
                                        F@_1,
                                        TrUserData).

skip_length_delimited_get_task_request(<<1:1, X:7,
                                         Rest/binary>>,
                                       N, Acc, F@_1, TrUserData)
    when N < 57 ->
    skip_length_delimited_get_task_request(Rest,
                                           N + 7,
                                           X bsl N + Acc,
                                           F@_1,
                                           TrUserData);
skip_length_delimited_get_task_request(<<0:1, X:7,
                                         Rest/binary>>,
                                       N, Acc, F@_1, TrUserData) ->
    Length = X bsl N + Acc,
    <<_:Length/binary, Rest2/binary>> = Rest,
    dfp_read_field_def_get_task_request(Rest2,
                                        0,
                                        0,
                                        F@_1,
                                        TrUserData).

skip_group_get_task_request(Bin, FNum, Z2, F@_1,
                            TrUserData) ->
    {_, Rest} = read_group(Bin, FNum),
    dfp_read_field_def_get_task_request(Rest,
                                        0,
                                        Z2,
                                        F@_1,
                                        TrUserData).

skip_32_get_task_request(<<_:32, Rest/binary>>, Z1, Z2,
                         F@_1, TrUserData) ->
    dfp_read_field_def_get_task_request(Rest,
                                        Z1,
                                        Z2,
                                        F@_1,
                                        TrUserData).

skip_64_get_task_request(<<_:64, Rest/binary>>, Z1, Z2,
                         F@_1, TrUserData) ->
    dfp_read_field_def_get_task_request(Rest,
                                        Z1,
                                        Z2,
                                        F@_1,
                                        TrUserData).

decode_msg_cancel_task_request(Bin, TrUserData) ->
    dfp_read_field_def_cancel_task_request(Bin,
                                           0,
                                           0,
                                           id(<<>>, TrUserData),
                                           TrUserData).

dfp_read_field_def_cancel_task_request(<<10,
                                         Rest/binary>>,
                                       Z1, Z2, F@_1, TrUserData) ->
    d_field_cancel_task_request_task_id(Rest,
                                        Z1,
                                        Z2,
                                        F@_1,
                                        TrUserData);
dfp_read_field_def_cancel_task_request(<<>>, 0, 0, F@_1,
                                       _) ->
    #{task_id => F@_1};
dfp_read_field_def_cancel_task_request(Other, Z1, Z2,
                                       F@_1, TrUserData) ->
    dg_read_field_def_cancel_task_request(Other,
                                          Z1,
                                          Z2,
                                          F@_1,
                                          TrUserData).

dg_read_field_def_cancel_task_request(<<1:1, X:7,
                                        Rest/binary>>,
                                      N, Acc, F@_1, TrUserData)
    when N < 32 - 7 ->
    dg_read_field_def_cancel_task_request(Rest,
                                          N + 7,
                                          X bsl N + Acc,
                                          F@_1,
                                          TrUserData);
dg_read_field_def_cancel_task_request(<<0:1, X:7,
                                        Rest/binary>>,
                                      N, Acc, F@_1, TrUserData) ->
    Key = X bsl N + Acc,
    case Key of
        10 ->
            d_field_cancel_task_request_task_id(Rest,
                                                0,
                                                0,
                                                F@_1,
                                                TrUserData);
        _ ->
            case Key band 7 of
                0 ->
                    skip_varint_cancel_task_request(Rest,
                                                    0,
                                                    0,
                                                    F@_1,
                                                    TrUserData);
                1 ->
                    skip_64_cancel_task_request(Rest,
                                                0,
                                                0,
                                                F@_1,
                                                TrUserData);
                2 ->
                    skip_length_delimited_cancel_task_request(Rest,
                                                              0,
                                                              0,
                                                              F@_1,
                                                              TrUserData);
                3 ->
                    skip_group_cancel_task_request(Rest,
                                                   Key bsr 3,
                                                   0,
                                                   F@_1,
                                                   TrUserData);
                5 ->
                    skip_32_cancel_task_request(Rest,
                                                0,
                                                0,
                                                F@_1,
                                                TrUserData)
            end
    end;
dg_read_field_def_cancel_task_request(<<>>, 0, 0, F@_1,
                                      _) ->
    #{task_id => F@_1}.

d_field_cancel_task_request_task_id(<<1:1, X:7,
                                      Rest/binary>>,
                                    N, Acc, F@_1, TrUserData)
    when N < 57 ->
    d_field_cancel_task_request_task_id(Rest,
                                        N + 7,
                                        X bsl N + Acc,
                                        F@_1,
                                        TrUserData);
d_field_cancel_task_request_task_id(<<0:1, X:7,
                                      Rest/binary>>,
                                    N, Acc, _, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bytes:Len/binary, Rest2/binary>> = Rest,
                             {id(binary:copy(Bytes), TrUserData), Rest2}
                         end,
    dfp_read_field_def_cancel_task_request(RestF,
                                           0,
                                           0,
                                           NewFValue,
                                           TrUserData).

skip_varint_cancel_task_request(<<1:1, _:7,
                                  Rest/binary>>,
                                Z1, Z2, F@_1, TrUserData) ->
    skip_varint_cancel_task_request(Rest,
                                    Z1,
                                    Z2,
                                    F@_1,
                                    TrUserData);
skip_varint_cancel_task_request(<<0:1, _:7,
                                  Rest/binary>>,
                                Z1, Z2, F@_1, TrUserData) ->
    dfp_read_field_def_cancel_task_request(Rest,
                                           Z1,
                                           Z2,
                                           F@_1,
                                           TrUserData).

skip_length_delimited_cancel_task_request(<<1:1, X:7,
                                            Rest/binary>>,
                                          N, Acc, F@_1, TrUserData)
    when N < 57 ->
    skip_length_delimited_cancel_task_request(Rest,
                                              N + 7,
                                              X bsl N + Acc,
                                              F@_1,
                                              TrUserData);
skip_length_delimited_cancel_task_request(<<0:1, X:7,
                                            Rest/binary>>,
                                          N, Acc, F@_1, TrUserData) ->
    Length = X bsl N + Acc,
    <<_:Length/binary, Rest2/binary>> = Rest,
    dfp_read_field_def_cancel_task_request(Rest2,
                                           0,
                                           0,
                                           F@_1,
                                           TrUserData).

skip_group_cancel_task_request(Bin, FNum, Z2, F@_1,
                               TrUserData) ->
    {_, Rest} = read_group(Bin, FNum),
    dfp_read_field_def_cancel_task_request(Rest,
                                           0,
                                           Z2,
                                           F@_1,
                                           TrUserData).

skip_32_cancel_task_request(<<_:32, Rest/binary>>, Z1,
                            Z2, F@_1, TrUserData) ->
    dfp_read_field_def_cancel_task_request(Rest,
                                           Z1,
                                           Z2,
                                           F@_1,
                                           TrUserData).

skip_64_cancel_task_request(<<_:64, Rest/binary>>, Z1,
                            Z2, F@_1, TrUserData) ->
    dfp_read_field_def_cancel_task_request(Rest,
                                           Z1,
                                           Z2,
                                           F@_1,
                                           TrUserData).

decode_msg_task(Bin, TrUserData) ->
    dfp_read_field_def_task(Bin,
                            0,
                            0,
                            id(<<>>, TrUserData),
                            id('$undef', TrUserData),
                            id('$undef', TrUserData),
                            id('UNDEFINED', TrUserData),
                            id('$undef', TrUserData),
                            TrUserData).

dfp_read_field_def_task(<<10, Rest/binary>>, Z1, Z2,
                        F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    d_field_task_id(Rest,
                    Z1,
                    Z2,
                    F@_1,
                    F@_2,
                    F@_3,
                    F@_4,
                    F@_5,
                    TrUserData);
dfp_read_field_def_task(<<18, Rest/binary>>, Z1, Z2,
                        F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    d_field_task_created_at(Rest,
                            Z1,
                            Z2,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData);
dfp_read_field_def_task(<<26, Rest/binary>>, Z1, Z2,
                        F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    d_field_task_updated_at(Rest,
                            Z1,
                            Z2,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData);
dfp_read_field_def_task(<<32, Rest/binary>>, Z1, Z2,
                        F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    d_field_task_status(Rest,
                        Z1,
                        Z2,
                        F@_1,
                        F@_2,
                        F@_3,
                        F@_4,
                        F@_5,
                        TrUserData);
dfp_read_field_def_task(<<42, Rest/binary>>, Z1, Z2,
                        F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    d_field_task_error(Rest,
                       Z1,
                       Z2,
                       F@_1,
                       F@_2,
                       F@_3,
                       F@_4,
                       F@_5,
                       TrUserData);
dfp_read_field_def_task(<<50, Rest/binary>>, Z1, Z2,
                        F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    d_field_task_response_file_id(Rest,
                                  Z1,
                                  Z2,
                                  F@_1,
                                  F@_2,
                                  F@_3,
                                  F@_4,
                                  F@_5,
                                  TrUserData);
dfp_read_field_def_task(<<>>, 0, 0, F@_1, F@_2, F@_3,
                        F@_4, F@_5, _) ->
    S1 = #{id => F@_1, status => F@_4},
    S2 = if F@_2 == '$undef' -> S1;
            true -> S1#{created_at => F@_2}
         end,
    S3 = if F@_3 == '$undef' -> S2;
            true -> S2#{updated_at => F@_3}
         end,
    if F@_5 == '$undef' -> S3;
       true -> S3#{result => F@_5}
    end;
dfp_read_field_def_task(Other, Z1, Z2, F@_1, F@_2, F@_3,
                        F@_4, F@_5, TrUserData) ->
    dg_read_field_def_task(Other,
                           Z1,
                           Z2,
                           F@_1,
                           F@_2,
                           F@_3,
                           F@_4,
                           F@_5,
                           TrUserData).

dg_read_field_def_task(<<1:1, X:7, Rest/binary>>, N,
                       Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 32 - 7 ->
    dg_read_field_def_task(Rest,
                           N + 7,
                           X bsl N + Acc,
                           F@_1,
                           F@_2,
                           F@_3,
                           F@_4,
                           F@_5,
                           TrUserData);
dg_read_field_def_task(<<0:1, X:7, Rest/binary>>, N,
                       Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    Key = X bsl N + Acc,
    case Key of
        10 ->
            d_field_task_id(Rest,
                            0,
                            0,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData);
        18 ->
            d_field_task_created_at(Rest,
                                    0,
                                    0,
                                    F@_1,
                                    F@_2,
                                    F@_3,
                                    F@_4,
                                    F@_5,
                                    TrUserData);
        26 ->
            d_field_task_updated_at(Rest,
                                    0,
                                    0,
                                    F@_1,
                                    F@_2,
                                    F@_3,
                                    F@_4,
                                    F@_5,
                                    TrUserData);
        32 ->
            d_field_task_status(Rest,
                                0,
                                0,
                                F@_1,
                                F@_2,
                                F@_3,
                                F@_4,
                                F@_5,
                                TrUserData);
        42 ->
            d_field_task_error(Rest,
                               0,
                               0,
                               F@_1,
                               F@_2,
                               F@_3,
                               F@_4,
                               F@_5,
                               TrUserData);
        50 ->
            d_field_task_response_file_id(Rest,
                                          0,
                                          0,
                                          F@_1,
                                          F@_2,
                                          F@_3,
                                          F@_4,
                                          F@_5,
                                          TrUserData);
        _ ->
            case Key band 7 of
                0 ->
                    skip_varint_task(Rest,
                                     0,
                                     0,
                                     F@_1,
                                     F@_2,
                                     F@_3,
                                     F@_4,
                                     F@_5,
                                     TrUserData);
                1 ->
                    skip_64_task(Rest,
                                 0,
                                 0,
                                 F@_1,
                                 F@_2,
                                 F@_3,
                                 F@_4,
                                 F@_5,
                                 TrUserData);
                2 ->
                    skip_length_delimited_task(Rest,
                                               0,
                                               0,
                                               F@_1,
                                               F@_2,
                                               F@_3,
                                               F@_4,
                                               F@_5,
                                               TrUserData);
                3 ->
                    skip_group_task(Rest,
                                    Key bsr 3,
                                    0,
                                    F@_1,
                                    F@_2,
                                    F@_3,
                                    F@_4,
                                    F@_5,
                                    TrUserData);
                5 ->
                    skip_32_task(Rest,
                                 0,
                                 0,
                                 F@_1,
                                 F@_2,
                                 F@_3,
                                 F@_4,
                                 F@_5,
                                 TrUserData)
            end
    end;
dg_read_field_def_task(<<>>, 0, 0, F@_1, F@_2, F@_3,
                       F@_4, F@_5, _) ->
    S1 = #{id => F@_1, status => F@_4},
    S2 = if F@_2 == '$undef' -> S1;
            true -> S1#{created_at => F@_2}
         end,
    S3 = if F@_3 == '$undef' -> S2;
            true -> S2#{updated_at => F@_3}
         end,
    if F@_5 == '$undef' -> S3;
       true -> S3#{result => F@_5}
    end.

d_field_task_id(<<1:1, X:7, Rest/binary>>, N, Acc, F@_1,
                F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    d_field_task_id(Rest,
                    N + 7,
                    X bsl N + Acc,
                    F@_1,
                    F@_2,
                    F@_3,
                    F@_4,
                    F@_5,
                    TrUserData);
d_field_task_id(<<0:1, X:7, Rest/binary>>, N, Acc, _,
                F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bytes:Len/binary, Rest2/binary>> = Rest,
                             {id(binary:copy(Bytes), TrUserData), Rest2}
                         end,
    dfp_read_field_def_task(RestF,
                            0,
                            0,
                            NewFValue,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

d_field_task_created_at(<<1:1, X:7, Rest/binary>>, N,
                        Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    d_field_task_created_at(Rest,
                            N + 7,
                            X bsl N + Acc,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData);
d_field_task_created_at(<<0:1, X:7, Rest/binary>>, N,
                        Acc, F@_1, Prev, F@_3, F@_4, F@_5, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bs:Len/binary, Rest2/binary>> = Rest,
                             {id(decode_msg_timestamp(Bs, TrUserData),
                                 TrUserData),
                              Rest2}
                         end,
    dfp_read_field_def_task(RestF,
                            0,
                            0,
                            F@_1,
                            if Prev == '$undef' -> NewFValue;
                               true ->
                                   merge_msg_timestamp(Prev,
                                                       NewFValue,
                                                       TrUserData)
                            end,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

d_field_task_updated_at(<<1:1, X:7, Rest/binary>>, N,
                        Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    d_field_task_updated_at(Rest,
                            N + 7,
                            X bsl N + Acc,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData);
d_field_task_updated_at(<<0:1, X:7, Rest/binary>>, N,
                        Acc, F@_1, F@_2, Prev, F@_4, F@_5, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bs:Len/binary, Rest2/binary>> = Rest,
                             {id(decode_msg_timestamp(Bs, TrUserData),
                                 TrUserData),
                              Rest2}
                         end,
    dfp_read_field_def_task(RestF,
                            0,
                            0,
                            F@_1,
                            F@_2,
                            if Prev == '$undef' -> NewFValue;
                               true ->
                                   merge_msg_timestamp(Prev,
                                                       NewFValue,
                                                       TrUserData)
                            end,
                            F@_4,
                            F@_5,
                            TrUserData).

d_field_task_status(<<1:1, X:7, Rest/binary>>, N, Acc,
                    F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    d_field_task_status(Rest,
                        N + 7,
                        X bsl N + Acc,
                        F@_1,
                        F@_2,
                        F@_3,
                        F@_4,
                        F@_5,
                        TrUserData);
d_field_task_status(<<0:1, X:7, Rest/binary>>, N, Acc,
                    F@_1, F@_2, F@_3, _, F@_5, TrUserData) ->
    {NewFValue, RestF} = {id('d_enum_task.Status'(begin
                                                      <<Res:32/signed-native>> =
                                                          <<(X bsl N +
                                                                 Acc):32/unsigned-native>>,
                                                      id(Res, TrUserData)
                                                  end),
                             TrUserData),
                          Rest},
    dfp_read_field_def_task(RestF,
                            0,
                            0,
                            F@_1,
                            F@_2,
                            F@_3,
                            NewFValue,
                            F@_5,
                            TrUserData).

d_field_task_error(<<1:1, X:7, Rest/binary>>, N, Acc,
                   F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    d_field_task_error(Rest,
                       N + 7,
                       X bsl N + Acc,
                       F@_1,
                       F@_2,
                       F@_3,
                       F@_4,
                       F@_5,
                       TrUserData);
d_field_task_error(<<0:1, X:7, Rest/binary>>, N, Acc,
                   F@_1, F@_2, F@_3, F@_4, _, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bytes:Len/binary, Rest2/binary>> = Rest,
                             {id(binary:copy(Bytes), TrUserData), Rest2}
                         end,
    dfp_read_field_def_task(RestF,
                            0,
                            0,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            id({error, NewFValue}, TrUserData),
                            TrUserData).

d_field_task_response_file_id(<<1:1, X:7, Rest/binary>>,
                              N, Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    d_field_task_response_file_id(Rest,
                                  N + 7,
                                  X bsl N + Acc,
                                  F@_1,
                                  F@_2,
                                  F@_3,
                                  F@_4,
                                  F@_5,
                                  TrUserData);
d_field_task_response_file_id(<<0:1, X:7, Rest/binary>>,
                              N, Acc, F@_1, F@_2, F@_3, F@_4, _, TrUserData) ->
    {NewFValue, RestF} = begin
                             Len = X bsl N + Acc,
                             <<Bytes:Len/binary, Rest2/binary>> = Rest,
                             {id(binary:copy(Bytes), TrUserData), Rest2}
                         end,
    dfp_read_field_def_task(RestF,
                            0,
                            0,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            id({response_file_id, NewFValue}, TrUserData),
                            TrUserData).

skip_varint_task(<<1:1, _:7, Rest/binary>>, Z1, Z2,
                 F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    skip_varint_task(Rest,
                     Z1,
                     Z2,
                     F@_1,
                     F@_2,
                     F@_3,
                     F@_4,
                     F@_5,
                     TrUserData);
skip_varint_task(<<0:1, _:7, Rest/binary>>, Z1, Z2,
                 F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    dfp_read_field_def_task(Rest,
                            Z1,
                            Z2,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

skip_length_delimited_task(<<1:1, X:7, Rest/binary>>, N,
                           Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData)
    when N < 57 ->
    skip_length_delimited_task(Rest,
                               N + 7,
                               X bsl N + Acc,
                               F@_1,
                               F@_2,
                               F@_3,
                               F@_4,
                               F@_5,
                               TrUserData);
skip_length_delimited_task(<<0:1, X:7, Rest/binary>>, N,
                           Acc, F@_1, F@_2, F@_3, F@_4, F@_5, TrUserData) ->
    Length = X bsl N + Acc,
    <<_:Length/binary, Rest2/binary>> = Rest,
    dfp_read_field_def_task(Rest2,
                            0,
                            0,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

skip_group_task(Bin, FNum, Z2, F@_1, F@_2, F@_3, F@_4,
                F@_5, TrUserData) ->
    {_, Rest} = read_group(Bin, FNum),
    dfp_read_field_def_task(Rest,
                            0,
                            Z2,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

skip_32_task(<<_:32, Rest/binary>>, Z1, Z2, F@_1, F@_2,
             F@_3, F@_4, F@_5, TrUserData) ->
    dfp_read_field_def_task(Rest,
                            Z1,
                            Z2,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

skip_64_task(<<_:64, Rest/binary>>, Z1, Z2, F@_1, F@_2,
             F@_3, F@_4, F@_5, TrUserData) ->
    dfp_read_field_def_task(Rest,
                            Z1,
                            Z2,
                            F@_1,
                            F@_2,
                            F@_3,
                            F@_4,
                            F@_5,
                            TrUserData).

decode_msg_timestamp(Bin, TrUserData) ->
    dfp_read_field_def_timestamp(Bin,
                                 0,
                                 0,
                                 id(0, TrUserData),
                                 id(0, TrUserData),
                                 TrUserData).

dfp_read_field_def_timestamp(<<8, Rest/binary>>, Z1, Z2,
                             F@_1, F@_2, TrUserData) ->
    d_field_timestamp_seconds(Rest,
                              Z1,
                              Z2,
                              F@_1,
                              F@_2,
                              TrUserData);
dfp_read_field_def_timestamp(<<16, Rest/binary>>, Z1,
                             Z2, F@_1, F@_2, TrUserData) ->
    d_field_timestamp_nanos(Rest,
                            Z1,
                            Z2,
                            F@_1,
                            F@_2,
                            TrUserData);
dfp_read_field_def_timestamp(<<>>, 0, 0, F@_1, F@_2,
                             _) ->
    #{seconds => F@_1, nanos => F@_2};
dfp_read_field_def_timestamp(Other, Z1, Z2, F@_1, F@_2,
                             TrUserData) ->
    dg_read_field_def_timestamp(Other,
                                Z1,
                                Z2,
                                F@_1,
                                F@_2,
                                TrUserData).

dg_read_field_def_timestamp(<<1:1, X:7, Rest/binary>>,
                            N, Acc, F@_1, F@_2, TrUserData)
    when N < 32 - 7 ->
    dg_read_field_def_timestamp(Rest,
                                N + 7,
                                X bsl N + Acc,
                                F@_1,
                                F@_2,
                                TrUserData);
dg_read_field_def_timestamp(<<0:1, X:7, Rest/binary>>,
                            N, Acc, F@_1, F@_2, TrUserData) ->
    Key = X bsl N + Acc,
    case Key of
        8 ->
            d_field_timestamp_seconds(Rest,
                                      0,
                                      0,
                                      F@_1,
                                      F@_2,
                                      TrUserData);
        16 ->
            d_field_timestamp_nanos(Rest,
                                    0,
                                    0,
                                    F@_1,
                                    F@_2,
                                    TrUserData);
        _ ->
            case Key band 7 of
                0 ->
                    skip_varint_timestamp(Rest,
                                          0,
                                          0,
                                          F@_1,
                                          F@_2,
                                          TrUserData);
                1 ->
                    skip_64_timestamp(Rest, 0, 0, F@_1, F@_2, TrUserData);
                2 ->
                    skip_length_delimited_timestamp(Rest,
                                                    0,
                                                    0,
                                                    F@_1,
                                                    F@_2,
                                                    TrUserData);
                3 ->
                    skip_group_timestamp(Rest,
                                         Key bsr 3,
                                         0,
                                         F@_1,
                                         F@_2,
                                         TrUserData);
                5 ->
                    skip_32_timestamp(Rest, 0, 0, F@_1, F@_2, TrUserData)
            end
    end;
dg_read_field_def_timestamp(<<>>, 0, 0, F@_1, F@_2,
                            _) ->
    #{seconds => F@_1, nanos => F@_2}.

d_field_timestamp_seconds(<<1:1, X:7, Rest/binary>>, N,
                          Acc, F@_1, F@_2, TrUserData)
    when N < 57 ->
    d_field_timestamp_seconds(Rest,
                              N + 7,
                              X bsl N + Acc,
                              F@_1,
                              F@_2,
                              TrUserData);
d_field_timestamp_seconds(<<0:1, X:7, Rest/binary>>, N,
                          Acc, _, F@_2, TrUserData) ->
    {NewFValue, RestF} = {begin
                              <<Res:64/signed-native>> = <<(X bsl N +
                                                                Acc):64/unsigned-native>>,
                              id(Res, TrUserData)
                          end,
                          Rest},
    dfp_read_field_def_timestamp(RestF,
                                 0,
                                 0,
                                 NewFValue,
                                 F@_2,
                                 TrUserData).

d_field_timestamp_nanos(<<1:1, X:7, Rest/binary>>, N,
                        Acc, F@_1, F@_2, TrUserData)
    when N < 57 ->
    d_field_timestamp_nanos(Rest,
                            N + 7,
                            X bsl N + Acc,
                            F@_1,
                            F@_2,
                            TrUserData);
d_field_timestamp_nanos(<<0:1, X:7, Rest/binary>>, N,
                        Acc, F@_1, _, TrUserData) ->
    {NewFValue, RestF} = {begin
                              <<Res:32/signed-native>> = <<(X bsl N +
                                                                Acc):32/unsigned-native>>,
                              id(Res, TrUserData)
                          end,
                          Rest},
    dfp_read_field_def_timestamp(RestF,
                                 0,
                                 0,
                                 F@_1,
                                 NewFValue,
                                 TrUserData).

skip_varint_timestamp(<<1:1, _:7, Rest/binary>>, Z1, Z2,
                      F@_1, F@_2, TrUserData) ->
    skip_varint_timestamp(Rest,
                          Z1,
                          Z2,
                          F@_1,
                          F@_2,
                          TrUserData);
skip_varint_timestamp(<<0:1, _:7, Rest/binary>>, Z1, Z2,
                      F@_1, F@_2, TrUserData) ->
    dfp_read_field_def_timestamp(Rest,
                                 Z1,
                                 Z2,
                                 F@_1,
                                 F@_2,
                                 TrUserData).

skip_length_delimited_timestamp(<<1:1, X:7,
                                  Rest/binary>>,
                                N, Acc, F@_1, F@_2, TrUserData)
    when N < 57 ->
    skip_length_delimited_timestamp(Rest,
                                    N + 7,
                                    X bsl N + Acc,
                                    F@_1,
                                    F@_2,
                                    TrUserData);
skip_length_delimited_timestamp(<<0:1, X:7,
                                  Rest/binary>>,
                                N, Acc, F@_1, F@_2, TrUserData) ->
    Length = X bsl N + Acc,
    <<_:Length/binary, Rest2/binary>> = Rest,
    dfp_read_field_def_timestamp(Rest2,
                                 0,
                                 0,
                                 F@_1,
                                 F@_2,
                                 TrUserData).

skip_group_timestamp(Bin, FNum, Z2, F@_1, F@_2,
                     TrUserData) ->
    {_, Rest} = read_group(Bin, FNum),
    dfp_read_field_def_timestamp(Rest,
                                 0,
                                 Z2,
                                 F@_1,
                                 F@_2,
                                 TrUserData).

skip_32_timestamp(<<_:32, Rest/binary>>, Z1, Z2, F@_1,
                  F@_2, TrUserData) ->
    dfp_read_field_def_timestamp(Rest,
                                 Z1,
                                 Z2,
                                 F@_1,
                                 F@_2,
                                 TrUserData).

skip_64_timestamp(<<_:64, Rest/binary>>, Z1, Z2, F@_1,
                  F@_2, TrUserData) ->
    dfp_read_field_def_timestamp(Rest,
                                 Z1,
                                 Z2,
                                 F@_1,
                                 F@_2,
                                 TrUserData).

'd_enum_task.Status'(0) -> 'UNDEFINED';
'd_enum_task.Status'(1) -> 'NEW';
'd_enum_task.Status'(2) -> 'RUNNING';
'd_enum_task.Status'(3) -> 'CANCELED';
'd_enum_task.Status'(4) -> 'DONE';
'd_enum_task.Status'(5) -> 'ERROR';
'd_enum_task.Status'(V) -> V.

read_group(Bin, FieldNum) ->
    {NumBytes, EndTagLen} = read_gr_b(Bin, 0, 0, 0, 0, FieldNum),
    <<Group:NumBytes/binary, _:EndTagLen/binary, Rest/binary>> = Bin,
    {Group, Rest}.

%% Like skipping over fields, but record the total length,
%% Each field is <(FieldNum bsl 3) bor FieldType> ++ <FieldValue>
%% Record the length because varints may be non-optimally encoded.
%%
%% Groups can be nested, but assume the same FieldNum cannot be nested
%% because group field numbers are shared with the rest of the fields
%% numbers. Thus we can search just for an group-end with the same
%% field number.
%%
%% (The only time the same group field number could occur would
%% be in a nested sub message, but then it would be inside a
%% length-delimited entry, which we skip-read by length.)
read_gr_b(<<1:1, X:7, Tl/binary>>, N, Acc, NumBytes, TagLen, FieldNum)
  when N < (32-7) ->
    read_gr_b(Tl, N+7, X bsl N + Acc, NumBytes, TagLen+1, FieldNum);
read_gr_b(<<0:1, X:7, Tl/binary>>, N, Acc, NumBytes, TagLen,
          FieldNum) ->
    Key = X bsl N + Acc,
    TagLen1 = TagLen + 1,
    case {Key bsr 3, Key band 7} of
        {FieldNum, 4} -> % 4 = group_end
            {NumBytes, TagLen1};
        {_, 0} -> % 0 = varint
            read_gr_vi(Tl, 0, NumBytes + TagLen1, FieldNum);
        {_, 1} -> % 1 = bits64
            <<_:64, Tl2/binary>> = Tl,
            read_gr_b(Tl2, 0, 0, NumBytes + TagLen1 + 8, 0, FieldNum);
        {_, 2} -> % 2 = length_delimited
            read_gr_ld(Tl, 0, 0, NumBytes + TagLen1, FieldNum);
        {_, 3} -> % 3 = group_start
            read_gr_b(Tl, 0, 0, NumBytes + TagLen1, 0, FieldNum);
        {_, 4} -> % 4 = group_end
            read_gr_b(Tl, 0, 0, NumBytes + TagLen1, 0, FieldNum);
        {_, 5} -> % 5 = bits32
            <<_:32, Tl2/binary>> = Tl,
            read_gr_b(Tl2, 0, 0, NumBytes + TagLen1 + 4, 0, FieldNum)
    end.

read_gr_vi(<<1:1, _:7, Tl/binary>>, N, NumBytes, FieldNum)
  when N < (64-7) ->
    read_gr_vi(Tl, N+7, NumBytes+1, FieldNum);
read_gr_vi(<<0:1, _:7, Tl/binary>>, _, NumBytes, FieldNum) ->
    read_gr_b(Tl, 0, 0, NumBytes+1, 0, FieldNum).

read_gr_ld(<<1:1, X:7, Tl/binary>>, N, Acc, NumBytes, FieldNum)
  when N < (64-7) ->
    read_gr_ld(Tl, N+7, X bsl N + Acc, NumBytes+1, FieldNum);
read_gr_ld(<<0:1, X:7, Tl/binary>>, N, Acc, NumBytes, FieldNum) ->
    Len = X bsl N + Acc,
    NumBytes1 = NumBytes + 1,
    <<_:Len/binary, Tl2/binary>> = Tl,
    read_gr_b(Tl2, 0, 0, NumBytes1 + Len, 0, FieldNum).

merge_msgs(Prev, New, MsgName) when is_atom(MsgName) ->
    merge_msgs(Prev, New, MsgName, []).

merge_msgs(Prev, New, MsgName, Opts) ->
    TrUserData = proplists:get_value(user_data, Opts),
    case MsgName of
        get_task_request ->
            merge_msg_get_task_request(Prev, New, TrUserData);
        cancel_task_request ->
            merge_msg_cancel_task_request(Prev, New, TrUserData);
        task -> merge_msg_task(Prev, New, TrUserData);
        timestamp -> merge_msg_timestamp(Prev, New, TrUserData)
    end.

-compile({nowarn_unused_function,merge_msg_get_task_request/3}).
merge_msg_get_task_request(PMsg, NMsg, _) ->
    S1 = #{},
    case {PMsg, NMsg} of
        {_, #{task_id := NFtask_id}} ->
            S1#{task_id => NFtask_id};
        {#{task_id := PFtask_id}, _} ->
            S1#{task_id => PFtask_id};
        _ -> S1
    end.

-compile({nowarn_unused_function,merge_msg_cancel_task_request/3}).
merge_msg_cancel_task_request(PMsg, NMsg, _) ->
    S1 = #{},
    case {PMsg, NMsg} of
        {_, #{task_id := NFtask_id}} ->
            S1#{task_id => NFtask_id};
        {#{task_id := PFtask_id}, _} ->
            S1#{task_id => PFtask_id};
        _ -> S1
    end.

-compile({nowarn_unused_function,merge_msg_task/3}).
merge_msg_task(PMsg, NMsg, TrUserData) ->
    S1 = #{},
    S2 = case {PMsg, NMsg} of
             {_, #{id := NFid}} -> S1#{id => NFid};
             {#{id := PFid}, _} -> S1#{id => PFid};
             _ -> S1
         end,
    S3 = case {PMsg, NMsg} of
             {#{created_at := PFcreated_at},
              #{created_at := NFcreated_at}} ->
                 S2#{created_at =>
                         merge_msg_timestamp(PFcreated_at,
                                             NFcreated_at,
                                             TrUserData)};
             {_, #{created_at := NFcreated_at}} ->
                 S2#{created_at => NFcreated_at};
             {#{created_at := PFcreated_at}, _} ->
                 S2#{created_at => PFcreated_at};
             {_, _} -> S2
         end,
    S4 = case {PMsg, NMsg} of
             {#{updated_at := PFupdated_at},
              #{updated_at := NFupdated_at}} ->
                 S3#{updated_at =>
                         merge_msg_timestamp(PFupdated_at,
                                             NFupdated_at,
                                             TrUserData)};
             {_, #{updated_at := NFupdated_at}} ->
                 S3#{updated_at => NFupdated_at};
             {#{updated_at := PFupdated_at}, _} ->
                 S3#{updated_at => PFupdated_at};
             {_, _} -> S3
         end,
    S5 = case {PMsg, NMsg} of
             {_, #{status := NFstatus}} -> S4#{status => NFstatus};
             {#{status := PFstatus}, _} -> S4#{status => PFstatus};
             _ -> S4
         end,
    case {PMsg, NMsg} of
        {_, #{result := NFresult}} -> S5#{result => NFresult};
        {#{result := PFresult}, _} -> S5#{result => PFresult};
        _ -> S5
    end.

-compile({nowarn_unused_function,merge_msg_timestamp/3}).
merge_msg_timestamp(PMsg, NMsg, _) ->
    S1 = #{},
    S2 = case {PMsg, NMsg} of
             {_, #{seconds := NFseconds}} ->
                 S1#{seconds => NFseconds};
             {#{seconds := PFseconds}, _} ->
                 S1#{seconds => PFseconds};
             _ -> S1
         end,
    case {PMsg, NMsg} of
        {_, #{nanos := NFnanos}} -> S2#{nanos => NFnanos};
        {#{nanos := PFnanos}, _} -> S2#{nanos => PFnanos};
        _ -> S2
    end.


verify_msg(Msg, MsgName) when is_atom(MsgName) ->
    verify_msg(Msg, MsgName, []).

verify_msg(Msg, MsgName, Opts) ->
    TrUserData = proplists:get_value(user_data, Opts),
    case MsgName of
        get_task_request ->
            v_msg_get_task_request(Msg, [MsgName], TrUserData);
        cancel_task_request ->
            v_msg_cancel_task_request(Msg, [MsgName], TrUserData);
        task -> v_msg_task(Msg, [MsgName], TrUserData);
        timestamp ->
            v_msg_timestamp(Msg, [MsgName], TrUserData);
        _ -> mk_type_error(not_a_known_message, Msg, [])
    end.


-compile({nowarn_unused_function,v_msg_get_task_request/3}).
-dialyzer({nowarn_function,v_msg_get_task_request/3}).
v_msg_get_task_request(#{} = M, Path, TrUserData) ->
    case M of
        #{task_id := F1} ->
            v_type_string(F1, [task_id | Path], TrUserData);
        _ -> ok
    end,
    lists:foreach(fun (task_id) -> ok;
                      (OtherKey) ->
                          mk_type_error({extraneous_key, OtherKey}, M, Path)
                  end,
                  maps:keys(M)),
    ok;
v_msg_get_task_request(M, Path, _TrUserData)
    when is_map(M) ->
    mk_type_error({missing_fields,
                   [] -- maps:keys(M),
                   get_task_request},
                  M,
                  Path);
v_msg_get_task_request(X, Path, _TrUserData) ->
    mk_type_error({expected_msg, get_task_request},
                  X,
                  Path).

-compile({nowarn_unused_function,v_msg_cancel_task_request/3}).
-dialyzer({nowarn_function,v_msg_cancel_task_request/3}).
v_msg_cancel_task_request(#{} = M, Path, TrUserData) ->
    case M of
        #{task_id := F1} ->
            v_type_string(F1, [task_id | Path], TrUserData);
        _ -> ok
    end,
    lists:foreach(fun (task_id) -> ok;
                      (OtherKey) ->
                          mk_type_error({extraneous_key, OtherKey}, M, Path)
                  end,
                  maps:keys(M)),
    ok;
v_msg_cancel_task_request(M, Path, _TrUserData)
    when is_map(M) ->
    mk_type_error({missing_fields,
                   [] -- maps:keys(M),
                   cancel_task_request},
                  M,
                  Path);
v_msg_cancel_task_request(X, Path, _TrUserData) ->
    mk_type_error({expected_msg, cancel_task_request},
                  X,
                  Path).

-compile({nowarn_unused_function,v_msg_task/3}).
-dialyzer({nowarn_function,v_msg_task/3}).
v_msg_task(#{} = M, Path, TrUserData) ->
    case M of
        #{id := F1} ->
            v_type_string(F1, [id | Path], TrUserData);
        _ -> ok
    end,
    case M of
        #{created_at := F2} ->
            v_msg_timestamp(F2, [created_at | Path], TrUserData);
        _ -> ok
    end,
    case M of
        #{updated_at := F3} ->
            v_msg_timestamp(F3, [updated_at | Path], TrUserData);
        _ -> ok
    end,
    case M of
        #{status := F4} ->
            'v_enum_task.Status'(F4, [status | Path], TrUserData);
        _ -> ok
    end,
    case M of
        #{result := {error, OF5}} ->
            v_type_string(OF5, [error, result | Path], TrUserData);
        #{result := {response_file_id, OF5}} ->
            v_type_string(OF5,
                          [response_file_id, result | Path],
                          TrUserData);
        #{result := F5} ->
            mk_type_error(invalid_oneof, F5, [result | Path]);
        _ -> ok
    end,
    lists:foreach(fun (id) -> ok;
                      (created_at) -> ok;
                      (updated_at) -> ok;
                      (status) -> ok;
                      (result) -> ok;
                      (OtherKey) ->
                          mk_type_error({extraneous_key, OtherKey}, M, Path)
                  end,
                  maps:keys(M)),
    ok;
v_msg_task(M, Path, _TrUserData) when is_map(M) ->
    mk_type_error({missing_fields,
                   [] -- maps:keys(M),
                   task},
                  M,
                  Path);
v_msg_task(X, Path, _TrUserData) ->
    mk_type_error({expected_msg, task}, X, Path).

-compile({nowarn_unused_function,v_msg_timestamp/3}).
-dialyzer({nowarn_function,v_msg_timestamp/3}).
v_msg_timestamp(#{} = M, Path, TrUserData) ->
    case M of
        #{seconds := F1} ->
            v_type_int64(F1, [seconds | Path], TrUserData);
        _ -> ok
    end,
    case M of
        #{nanos := F2} ->
            v_type_int32(F2, [nanos | Path], TrUserData);
        _ -> ok
    end,
    lists:foreach(fun (seconds) -> ok;
                      (nanos) -> ok;
                      (OtherKey) ->
                          mk_type_error({extraneous_key, OtherKey}, M, Path)
                  end,
                  maps:keys(M)),
    ok;
v_msg_timestamp(M, Path, _TrUserData) when is_map(M) ->
    mk_type_error({missing_fields,
                   [] -- maps:keys(M),
                   timestamp},
                  M,
                  Path);
v_msg_timestamp(X, Path, _TrUserData) ->
    mk_type_error({expected_msg, timestamp}, X, Path).

-compile({nowarn_unused_function,'v_enum_task.Status'/3}).
-dialyzer({nowarn_function,'v_enum_task.Status'/3}).
'v_enum_task.Status'('UNDEFINED', _Path, _TrUserData) ->
    ok;
'v_enum_task.Status'('NEW', _Path, _TrUserData) -> ok;
'v_enum_task.Status'('RUNNING', _Path, _TrUserData) ->
    ok;
'v_enum_task.Status'('CANCELED', _Path, _TrUserData) ->
    ok;
'v_enum_task.Status'('DONE', _Path, _TrUserData) -> ok;
'v_enum_task.Status'('ERROR', _Path, _TrUserData) -> ok;
'v_enum_task.Status'(V, Path, TrUserData)
    when is_integer(V) ->
    v_type_sint32(V, Path, TrUserData);
'v_enum_task.Status'(X, Path, _TrUserData) ->
    mk_type_error({invalid_enum, 'task.Status'}, X, Path).

-compile({nowarn_unused_function,v_type_sint32/3}).
-dialyzer({nowarn_function,v_type_sint32/3}).
v_type_sint32(N, _Path, _TrUserData)
    when -2147483648 =< N, N =< 2147483647 ->
    ok;
v_type_sint32(N, Path, _TrUserData)
    when is_integer(N) ->
    mk_type_error({value_out_of_range, sint32, signed, 32},
                  N,
                  Path);
v_type_sint32(X, Path, _TrUserData) ->
    mk_type_error({bad_integer, sint32, signed, 32},
                  X,
                  Path).

-compile({nowarn_unused_function,v_type_int32/3}).
-dialyzer({nowarn_function,v_type_int32/3}).
v_type_int32(N, _Path, _TrUserData)
    when -2147483648 =< N, N =< 2147483647 ->
    ok;
v_type_int32(N, Path, _TrUserData) when is_integer(N) ->
    mk_type_error({value_out_of_range, int32, signed, 32},
                  N,
                  Path);
v_type_int32(X, Path, _TrUserData) ->
    mk_type_error({bad_integer, int32, signed, 32},
                  X,
                  Path).

-compile({nowarn_unused_function,v_type_int64/3}).
-dialyzer({nowarn_function,v_type_int64/3}).
v_type_int64(N, _Path, _TrUserData)
    when -9223372036854775808 =< N,
         N =< 9223372036854775807 ->
    ok;
v_type_int64(N, Path, _TrUserData) when is_integer(N) ->
    mk_type_error({value_out_of_range, int64, signed, 64},
                  N,
                  Path);
v_type_int64(X, Path, _TrUserData) ->
    mk_type_error({bad_integer, int64, signed, 64},
                  X,
                  Path).

-compile({nowarn_unused_function,v_type_string/3}).
-dialyzer({nowarn_function,v_type_string/3}).
v_type_string(S, Path, _TrUserData)
    when is_list(S); is_binary(S) ->
    try unicode:characters_to_binary(S) of
        B when is_binary(B) -> ok;
        {error, _, _} ->
            mk_type_error(bad_unicode_string, S, Path)
    catch
        error:badarg ->
            mk_type_error(bad_unicode_string, S, Path)
    end;
v_type_string(X, Path, _TrUserData) ->
    mk_type_error(bad_unicode_string, X, Path).

-compile({nowarn_unused_function,mk_type_error/3}).
-spec mk_type_error(_, _, list()) -> no_return().
mk_type_error(Error, ValueSeen, Path) ->
    Path2 = prettify_path(Path),
    erlang:error({gpb_type_error,
                  {Error, [{value, ValueSeen}, {path, Path2}]}}).


-compile({nowarn_unused_function,prettify_path/1}).
-dialyzer({nowarn_function,prettify_path/1}).
prettify_path([]) -> top_level;
prettify_path(PathR) ->
    list_to_atom(lists:append(lists:join(".",
                                         lists:map(fun atom_to_list/1,
                                                   lists:reverse(PathR))))).


-compile({nowarn_unused_function,id/2}).
-compile({inline,id/2}).
id(X, _TrUserData) -> X.

-compile({nowarn_unused_function,v_ok/3}).
-compile({inline,v_ok/3}).
v_ok(_Value, _Path, _TrUserData) -> ok.

-compile({nowarn_unused_function,m_overwrite/3}).
-compile({inline,m_overwrite/3}).
m_overwrite(_Prev, New, _TrUserData) -> New.

-compile({nowarn_unused_function,cons/3}).
-compile({inline,cons/3}).
cons(Elem, Acc, _TrUserData) -> [Elem | Acc].

-compile({nowarn_unused_function,lists_reverse/2}).
-compile({inline,lists_reverse/2}).
'lists_reverse'(L, _TrUserData) -> lists:reverse(L).
-compile({nowarn_unused_function,'erlang_++'/3}).
-compile({inline,'erlang_++'/3}).
'erlang_++'(A, B, _TrUserData) -> A ++ B.

get_msg_defs() ->
    [{{enum, 'task.Status'},
      [{'UNDEFINED', 0},
       {'NEW', 1},
       {'RUNNING', 2},
       {'CANCELED', 3},
       {'DONE', 4},
       {'ERROR', 5}]},
     {{msg, get_task_request},
      [#{name => task_id, fnum => 1, rnum => 2,
         type => string, occurrence => optional, opts => []}]},
     {{msg, cancel_task_request},
      [#{name => task_id, fnum => 1, rnum => 2,
         type => string, occurrence => optional, opts => []}]},
     {{msg, task},
      [#{name => id, fnum => 1, rnum => 2, type => string,
         occurrence => optional, opts => []},
       #{name => created_at, fnum => 2, rnum => 3,
         type => {msg, timestamp}, occurrence => optional,
         opts => []},
       #{name => updated_at, fnum => 3, rnum => 4,
         type => {msg, timestamp}, occurrence => optional,
         opts => []},
       #{name => status, fnum => 4, rnum => 5,
         type => {enum, 'task.Status'}, occurrence => optional,
         opts => []},
       #{name => result, rnum => 6,
         fields =>
             [#{name => error, fnum => 5, rnum => 6, type => string,
                occurrence => optional, opts => []},
              #{name => response_file_id, fnum => 6, rnum => 6,
                type => string, occurrence => optional, opts => []}]}]},
     {{msg, timestamp},
      [#{name => seconds, fnum => 1, rnum => 2, type => int64,
         occurrence => optional, opts => []},
       #{name => nanos, fnum => 2, rnum => 3, type => int32,
         occurrence => optional, opts => []}]}].


get_msg_names() ->
    [get_task_request,
     cancel_task_request,
     task,
     timestamp].


get_group_names() -> [].


get_msg_or_group_names() ->
    [get_task_request,
     cancel_task_request,
     task,
     timestamp].


get_enum_names() -> ['task.Status'].


fetch_msg_def(MsgName) ->
    case find_msg_def(MsgName) of
        Fs when is_list(Fs) -> Fs;
        error -> erlang:error({no_such_msg, MsgName})
    end.


fetch_enum_def(EnumName) ->
    case find_enum_def(EnumName) of
        Es when is_list(Es) -> Es;
        error -> erlang:error({no_such_enum, EnumName})
    end.


find_msg_def(get_task_request) ->
    [#{name => task_id, fnum => 1, rnum => 2,
       type => string, occurrence => optional, opts => []}];
find_msg_def(cancel_task_request) ->
    [#{name => task_id, fnum => 1, rnum => 2,
       type => string, occurrence => optional, opts => []}];
find_msg_def(task) ->
    [#{name => id, fnum => 1, rnum => 2, type => string,
       occurrence => optional, opts => []},
     #{name => created_at, fnum => 2, rnum => 3,
       type => {msg, timestamp}, occurrence => optional,
       opts => []},
     #{name => updated_at, fnum => 3, rnum => 4,
       type => {msg, timestamp}, occurrence => optional,
       opts => []},
     #{name => status, fnum => 4, rnum => 5,
       type => {enum, 'task.Status'}, occurrence => optional,
       opts => []},
     #{name => result, rnum => 6,
       fields =>
           [#{name => error, fnum => 5, rnum => 6, type => string,
              occurrence => optional, opts => []},
            #{name => response_file_id, fnum => 6, rnum => 6,
              type => string, occurrence => optional, opts => []}]}];
find_msg_def(timestamp) ->
    [#{name => seconds, fnum => 1, rnum => 2, type => int64,
       occurrence => optional, opts => []},
     #{name => nanos, fnum => 2, rnum => 3, type => int32,
       occurrence => optional, opts => []}];
find_msg_def(_) -> error.


find_enum_def('task.Status') ->
    [{'UNDEFINED', 0},
     {'NEW', 1},
     {'RUNNING', 2},
     {'CANCELED', 3},
     {'DONE', 4},
     {'ERROR', 5}];
find_enum_def(_) -> error.


enum_symbol_by_value('task.Status', Value) ->
    'enum_symbol_by_value_task.Status'(Value).


enum_value_by_symbol('task.Status', Sym) ->
    'enum_value_by_symbol_task.Status'(Sym).


'enum_symbol_by_value_task.Status'(0) -> 'UNDEFINED';
'enum_symbol_by_value_task.Status'(1) -> 'NEW';
'enum_symbol_by_value_task.Status'(2) -> 'RUNNING';
'enum_symbol_by_value_task.Status'(3) -> 'CANCELED';
'enum_symbol_by_value_task.Status'(4) -> 'DONE';
'enum_symbol_by_value_task.Status'(5) -> 'ERROR'.


'enum_value_by_symbol_task.Status'('UNDEFINED') -> 0;
'enum_value_by_symbol_task.Status'('NEW') -> 1;
'enum_value_by_symbol_task.Status'('RUNNING') -> 2;
'enum_value_by_symbol_task.Status'('CANCELED') -> 3;
'enum_value_by_symbol_task.Status'('DONE') -> 4;
'enum_value_by_symbol_task.Status'('ERROR') -> 5.


get_service_names() ->
    ['smartspeech.task.v1.SmartSpeech'].


get_service_def('smartspeech.task.v1.SmartSpeech') ->
    {{service, 'smartspeech.task.v1.SmartSpeech'},
     [#{name => 'GetTask', input => get_task_request,
        output => task, input_stream => false,
        output_stream => false, opts => []},
      #{name => 'CancelTask', input => cancel_task_request,
        output => task, input_stream => false,
        output_stream => false, opts => []}]};
get_service_def(_) -> error.


get_rpc_names('smartspeech.task.v1.SmartSpeech') ->
    ['GetTask', 'CancelTask'];
get_rpc_names(_) -> error.


find_rpc_def('smartspeech.task.v1.SmartSpeech',
             RpcName) ->
    'find_rpc_def_smartspeech.task.v1.SmartSpeech'(RpcName);
find_rpc_def(_, _) -> error.


'find_rpc_def_smartspeech.task.v1.SmartSpeech'('GetTask') ->
    #{name => 'GetTask', input => get_task_request,
      output => task, input_stream => false,
      output_stream => false, opts => []};
'find_rpc_def_smartspeech.task.v1.SmartSpeech'('CancelTask') ->
    #{name => 'CancelTask', input => cancel_task_request,
      output => task, input_stream => false,
      output_stream => false, opts => []};
'find_rpc_def_smartspeech.task.v1.SmartSpeech'(_) ->
    error.


fetch_rpc_def(ServiceName, RpcName) ->
    case find_rpc_def(ServiceName, RpcName) of
        Def when is_map(Def) -> Def;
        error ->
            erlang:error({no_such_rpc, ServiceName, RpcName})
    end.


%% Convert a a fully qualified (ie with package name) service name
%% as a binary to a service name as an atom.
fqbin_to_service_name(<<"smartspeech.task.v1.SmartSpeech">>) ->
    'smartspeech.task.v1.SmartSpeech';
fqbin_to_service_name(X) ->
    error({gpb_error, {badservice, X}}).


%% Convert a service name as an atom to a fully qualified
%% (ie with package name) name as a binary.
service_name_to_fqbin('smartspeech.task.v1.SmartSpeech') ->
    <<"smartspeech.task.v1.SmartSpeech">>;
service_name_to_fqbin(X) ->
    error({gpb_error, {badservice, X}}).


%% Convert a a fully qualified (ie with package name) service name
%% and an rpc name, both as binaries to a service name and an rpc
%% name, as atoms.
fqbins_to_service_and_rpc_name(<<"smartspeech.task.v1.SmartSpeech">>, <<"GetTask">>) ->
    {'smartspeech.task.v1.SmartSpeech', 'GetTask'};
fqbins_to_service_and_rpc_name(<<"smartspeech.task.v1.SmartSpeech">>, <<"CancelTask">>) ->
    {'smartspeech.task.v1.SmartSpeech', 'CancelTask'};
fqbins_to_service_and_rpc_name(S, R) ->
    error({gpb_error, {badservice_or_rpc, {S, R}}}).


%% Convert a service name and an rpc name, both as atoms,
%% to a fully qualified (ie with package name) service name and
%% an rpc name as binaries.
service_and_rpc_name_to_fqbins('smartspeech.task.v1.SmartSpeech',
                               'GetTask') ->
    {<<"smartspeech.task.v1.SmartSpeech">>, <<"GetTask">>};
service_and_rpc_name_to_fqbins('smartspeech.task.v1.SmartSpeech',
                               'CancelTask') ->
    {<<"smartspeech.task.v1.SmartSpeech">>, <<"CancelTask">>};
service_and_rpc_name_to_fqbins(S, R) ->
    error({gpb_error, {badservice_or_rpc, {S, R}}}).


fqbin_to_msg_name(<<"smartspeech.task.v1.GetTaskRequest">>) -> get_task_request;
fqbin_to_msg_name(<<"smartspeech.task.v1.CancelTaskRequest">>) -> cancel_task_request;
fqbin_to_msg_name(<<"smartspeech.task.v1.Task">>) -> task;
fqbin_to_msg_name(<<"google.protobuf.Timestamp">>) -> timestamp;
fqbin_to_msg_name(E) -> error({gpb_error, {badmsg, E}}).


msg_name_to_fqbin(get_task_request) -> <<"smartspeech.task.v1.GetTaskRequest">>;
msg_name_to_fqbin(cancel_task_request) -> <<"smartspeech.task.v1.CancelTaskRequest">>;
msg_name_to_fqbin(task) -> <<"smartspeech.task.v1.Task">>;
msg_name_to_fqbin(timestamp) -> <<"google.protobuf.Timestamp">>;
msg_name_to_fqbin(E) -> error({gpb_error, {badmsg, E}}).


fqbin_to_enum_name(<<"smartspeech.task.v1.Task.Status">>) -> 'task.Status';
fqbin_to_enum_name(E) ->
    error({gpb_error, {badenum, E}}).


enum_name_to_fqbin('task.Status') -> <<"smartspeech.task.v1.Task.Status">>;
enum_name_to_fqbin(E) ->
    error({gpb_error, {badenum, E}}).


get_package_name() -> 'smartspeech.task.v1'.


%% Whether or not the message names
%% are prepended with package name or not.
uses_packages() -> true.


source_basename() -> "task.proto".


%% Retrieve all proto file names, also imported ones.
%% The order is top-down. The first element is always the main
%% source file. The files are returned with extension,
%% see get_all_proto_names/0 for a version that returns
%% the basenames sans extension
get_all_source_basenames() ->
    ["task.proto", "timestamp.proto"].


%% Retrieve all proto file names, also imported ones.
%% The order is top-down. The first element is always the main
%% source file. The files are returned sans .proto extension,
%% to make it easier to use them with the various get_xyz_containment
%% functions.
get_all_proto_names() -> ["task", "timestamp"].


get_msg_containment("task") ->
    [cancel_task_request, get_task_request, task];
get_msg_containment("timestamp") -> [timestamp];
get_msg_containment(P) ->
    error({gpb_error, {badproto, P}}).


get_pkg_containment("task") -> 'smartspeech.task.v1';
get_pkg_containment("timestamp") -> 'google.protobuf';
get_pkg_containment(P) ->
    error({gpb_error, {badproto, P}}).


get_service_containment("task") ->
    ['smartspeech.task.v1.SmartSpeech'];
get_service_containment("timestamp") -> [];
get_service_containment(P) ->
    error({gpb_error, {badproto, P}}).


get_rpc_containment("task") ->
    [{'smartspeech.task.v1.SmartSpeech', 'GetTask'},
     {'smartspeech.task.v1.SmartSpeech', 'CancelTask'}];
get_rpc_containment("timestamp") -> [];
get_rpc_containment(P) ->
    error({gpb_error, {badproto, P}}).


get_enum_containment("task") -> ['task.Status'];
get_enum_containment("timestamp") -> [];
get_enum_containment(P) ->
    error({gpb_error, {badproto, P}}).


get_proto_by_msg_name_as_fqbin(<<"google.protobuf.Timestamp">>) -> "timestamp";
get_proto_by_msg_name_as_fqbin(<<"smartspeech.task.v1.GetTaskRequest">>) -> "task";
get_proto_by_msg_name_as_fqbin(<<"smartspeech.task.v1.CancelTaskRequest">>) -> "task";
get_proto_by_msg_name_as_fqbin(<<"smartspeech.task.v1.Task">>) -> "task";
get_proto_by_msg_name_as_fqbin(E) ->
    error({gpb_error, {badmsg, E}}).


get_proto_by_service_name_as_fqbin(<<"smartspeech.task.v1.SmartSpeech">>) -> "task";
get_proto_by_service_name_as_fqbin(E) ->
    error({gpb_error, {badservice, E}}).


get_proto_by_enum_name_as_fqbin(<<"smartspeech.task.v1.Task.Status">>) -> "task";
get_proto_by_enum_name_as_fqbin(E) ->
    error({gpb_error, {badenum, E}}).


get_protos_by_pkg_name_as_fqbin(<<"smartspeech.task.v1">>) -> ["task"];
get_protos_by_pkg_name_as_fqbin(<<"google.protobuf">>) ->
    ["timestamp"];
get_protos_by_pkg_name_as_fqbin(E) ->
    error({gpb_error, {badpkg, E}}).


descriptor() ->
    <<10, 234, 4, 10, 30, 115, 109, 97, 114, 116, 115, 112,
      101, 101, 99, 104, 47, 116, 97, 115, 107, 47, 118, 49,
      47, 116, 97, 115, 107, 46, 112, 114, 111, 116, 111, 18,
      19, 115, 109, 97, 114, 116, 115, 112, 101, 101, 99, 104,
      46, 116, 97, 115, 107, 46, 118, 49, 34, 36, 10, 17, 67,
      97, 110, 99, 101, 108, 84, 97, 115, 107, 82, 101, 113,
      117, 101, 115, 116, 18, 15, 10, 7, 116, 97, 115, 107,
      95, 105, 100, 24, 1, 32, 1, 40, 9, 34, 33, 10, 14, 71,
      101, 116, 84, 97, 115, 107, 82, 101, 113, 117, 101, 115,
      116, 18, 15, 10, 7, 116, 97, 115, 107, 95, 105, 100, 24,
      1, 32, 1, 40, 9, 34, 173, 2, 10, 4, 84, 97, 115, 107,
      18, 10, 10, 2, 105, 100, 24, 1, 32, 1, 40, 9, 18, 46,
      10, 10, 99, 114, 101, 97, 116, 101, 100, 95, 97, 116,
      24, 2, 32, 1, 40, 11, 50, 26, 46, 103, 111, 111, 103,
      108, 101, 46, 112, 114, 111, 116, 111, 98, 117, 102, 46,
      84, 105, 109, 101, 115, 116, 97, 109, 112, 18, 46, 10,
      10, 117, 112, 100, 97, 116, 101, 100, 95, 97, 116, 24,
      3, 32, 1, 40, 11, 50, 26, 46, 103, 111, 111, 103, 108,
      101, 46, 112, 114, 111, 116, 111, 98, 117, 102, 46, 84,
      105, 109, 101, 115, 116, 97, 109, 112, 18, 48, 10, 6,
      115, 116, 97, 116, 117, 115, 24, 4, 32, 1, 40, 14, 50,
      32, 46, 115, 109, 97, 114, 116, 115, 112, 101, 101, 99,
      104, 46, 116, 97, 115, 107, 46, 118, 49, 46, 84, 97,
      115, 107, 46, 83, 116, 97, 116, 117, 115, 18, 15, 10, 5,
      101, 114, 114, 111, 114, 24, 5, 32, 1, 40, 9, 72, 0, 18,
      26, 10, 16, 114, 101, 115, 112, 111, 110, 115, 101, 95,
      102, 105, 108, 101, 95, 105, 100, 24, 6, 32, 1, 40, 9,
      72, 0, 34, 80, 10, 6, 83, 116, 97, 116, 117, 115, 18,
      13, 10, 9, 85, 78, 68, 69, 70, 73, 78, 69, 68, 16, 0,
      18, 7, 10, 3, 78, 69, 87, 16, 1, 18, 11, 10, 7, 82, 85,
      78, 78, 73, 78, 71, 16, 2, 18, 12, 10, 8, 67, 65, 78,
      67, 69, 76, 69, 68, 16, 3, 18, 8, 10, 4, 68, 79, 78, 69,
      16, 4, 18, 9, 10, 5, 69, 82, 82, 79, 82, 16, 5, 66, 8,
      10, 6, 114, 101, 115, 117, 108, 116, 50, 177, 1, 10, 11,
      83, 109, 97, 114, 116, 83, 112, 101, 101, 99, 104, 18,
      77, 10, 7, 71, 101, 116, 84, 97, 115, 107, 18, 35, 46,
      115, 109, 97, 114, 116, 115, 112, 101, 101, 99, 104, 46,
      116, 97, 115, 107, 46, 118, 49, 46, 71, 101, 116, 84,
      97, 115, 107, 82, 101, 113, 117, 101, 115, 116, 26, 25,
      46, 115, 109, 97, 114, 116, 115, 112, 101, 101, 99, 104,
      46, 116, 97, 115, 107, 46, 118, 49, 46, 84, 97, 115,
      107, 40, 0, 48, 0, 18, 83, 10, 10, 67, 97, 110, 99, 101,
      108, 84, 97, 115, 107, 18, 38, 46, 115, 109, 97, 114,
      116, 115, 112, 101, 101, 99, 104, 46, 116, 97, 115, 107,
      46, 118, 49, 46, 67, 97, 110, 99, 101, 108, 84, 97, 115,
      107, 82, 101, 113, 117, 101, 115, 116, 26, 25, 46, 115,
      109, 97, 114, 116, 115, 112, 101, 101, 99, 104, 46, 116,
      97, 115, 107, 46, 118, 49, 46, 84, 97, 115, 107, 40, 0,
      48, 0, 98, 6, 112, 114, 111, 116, 111, 51, 10, 103, 10,
      31, 103, 111, 111, 103, 108, 101, 47, 112, 114, 111,
      116, 111, 98, 117, 102, 47, 116, 105, 109, 101, 115,
      116, 97, 109, 112, 46, 112, 114, 111, 116, 111, 18, 15,
      103, 111, 111, 103, 108, 101, 46, 112, 114, 111, 116,
      111, 98, 117, 102, 34, 43, 10, 9, 84, 105, 109, 101,
      115, 116, 97, 109, 112, 18, 15, 10, 7, 115, 101, 99,
      111, 110, 100, 115, 24, 1, 32, 1, 40, 3, 18, 13, 10, 5,
      110, 97, 110, 111, 115, 24, 2, 32, 1, 40, 5, 98, 6, 112,
      114, 111, 116, 111, 51>>.

descriptor("task") ->
    <<10, 30, 115, 109, 97, 114, 116, 115, 112, 101, 101,
      99, 104, 47, 116, 97, 115, 107, 47, 118, 49, 47, 116,
      97, 115, 107, 46, 112, 114, 111, 116, 111, 18, 19, 115,
      109, 97, 114, 116, 115, 112, 101, 101, 99, 104, 46, 116,
      97, 115, 107, 46, 118, 49, 34, 36, 10, 17, 67, 97, 110,
      99, 101, 108, 84, 97, 115, 107, 82, 101, 113, 117, 101,
      115, 116, 18, 15, 10, 7, 116, 97, 115, 107, 95, 105,
      100, 24, 1, 32, 1, 40, 9, 34, 33, 10, 14, 71, 101, 116,
      84, 97, 115, 107, 82, 101, 113, 117, 101, 115, 116, 18,
      15, 10, 7, 116, 97, 115, 107, 95, 105, 100, 24, 1, 32,
      1, 40, 9, 34, 173, 2, 10, 4, 84, 97, 115, 107, 18, 10,
      10, 2, 105, 100, 24, 1, 32, 1, 40, 9, 18, 46, 10, 10,
      99, 114, 101, 97, 116, 101, 100, 95, 97, 116, 24, 2, 32,
      1, 40, 11, 50, 26, 46, 103, 111, 111, 103, 108, 101, 46,
      112, 114, 111, 116, 111, 98, 117, 102, 46, 84, 105, 109,
      101, 115, 116, 97, 109, 112, 18, 46, 10, 10, 117, 112,
      100, 97, 116, 101, 100, 95, 97, 116, 24, 3, 32, 1, 40,
      11, 50, 26, 46, 103, 111, 111, 103, 108, 101, 46, 112,
      114, 111, 116, 111, 98, 117, 102, 46, 84, 105, 109, 101,
      115, 116, 97, 109, 112, 18, 48, 10, 6, 115, 116, 97,
      116, 117, 115, 24, 4, 32, 1, 40, 14, 50, 32, 46, 115,
      109, 97, 114, 116, 115, 112, 101, 101, 99, 104, 46, 116,
      97, 115, 107, 46, 118, 49, 46, 84, 97, 115, 107, 46, 83,
      116, 97, 116, 117, 115, 18, 15, 10, 5, 101, 114, 114,
      111, 114, 24, 5, 32, 1, 40, 9, 72, 0, 18, 26, 10, 16,
      114, 101, 115, 112, 111, 110, 115, 101, 95, 102, 105,
      108, 101, 95, 105, 100, 24, 6, 32, 1, 40, 9, 72, 0, 34,
      80, 10, 6, 83, 116, 97, 116, 117, 115, 18, 13, 10, 9,
      85, 78, 68, 69, 70, 73, 78, 69, 68, 16, 0, 18, 7, 10, 3,
      78, 69, 87, 16, 1, 18, 11, 10, 7, 82, 85, 78, 78, 73,
      78, 71, 16, 2, 18, 12, 10, 8, 67, 65, 78, 67, 69, 76,
      69, 68, 16, 3, 18, 8, 10, 4, 68, 79, 78, 69, 16, 4, 18,
      9, 10, 5, 69, 82, 82, 79, 82, 16, 5, 66, 8, 10, 6, 114,
      101, 115, 117, 108, 116, 50, 177, 1, 10, 11, 83, 109,
      97, 114, 116, 83, 112, 101, 101, 99, 104, 18, 77, 10, 7,
      71, 101, 116, 84, 97, 115, 107, 18, 35, 46, 115, 109,
      97, 114, 116, 115, 112, 101, 101, 99, 104, 46, 116, 97,
      115, 107, 46, 118, 49, 46, 71, 101, 116, 84, 97, 115,
      107, 82, 101, 113, 117, 101, 115, 116, 26, 25, 46, 115,
      109, 97, 114, 116, 115, 112, 101, 101, 99, 104, 46, 116,
      97, 115, 107, 46, 118, 49, 46, 84, 97, 115, 107, 40, 0,
      48, 0, 18, 83, 10, 10, 67, 97, 110, 99, 101, 108, 84,
      97, 115, 107, 18, 38, 46, 115, 109, 97, 114, 116, 115,
      112, 101, 101, 99, 104, 46, 116, 97, 115, 107, 46, 118,
      49, 46, 67, 97, 110, 99, 101, 108, 84, 97, 115, 107, 82,
      101, 113, 117, 101, 115, 116, 26, 25, 46, 115, 109, 97,
      114, 116, 115, 112, 101, 101, 99, 104, 46, 116, 97, 115,
      107, 46, 118, 49, 46, 84, 97, 115, 107, 40, 0, 48, 0,
      98, 6, 112, 114, 111, 116, 111, 51>>;
descriptor("timestamp") ->
    <<10, 31, 103, 111, 111, 103, 108, 101, 47, 112, 114,
      111, 116, 111, 98, 117, 102, 47, 116, 105, 109, 101,
      115, 116, 97, 109, 112, 46, 112, 114, 111, 116, 111, 18,
      15, 103, 111, 111, 103, 108, 101, 46, 112, 114, 111,
      116, 111, 98, 117, 102, 34, 43, 10, 9, 84, 105, 109,
      101, 115, 116, 97, 109, 112, 18, 15, 10, 7, 115, 101,
      99, 111, 110, 100, 115, 24, 1, 32, 1, 40, 3, 18, 13, 10,
      5, 110, 97, 110, 111, 115, 24, 2, 32, 1, 40, 5, 98, 6,
      112, 114, 111, 116, 111, 51>>;
descriptor(X) -> error({gpb_error, {badname, X}}).


gpb_version_as_string() ->
    "4.7.3".

gpb_version_as_list() ->
    [4,7,3].
